Index: binaries/data/mods/public/shaders/glsl/ssao.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/ssao.fs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/ssao.fs	(revision 0)
@@ -0,0 +1,324 @@
+#version 110
+
+varying vec2 v_tex;
+
+uniform sampler2D bgl_RenderedTexture;
+uniform sampler2D bgl_DepthTexture;
+uniform sampler2D bgl_LuminanceTexture;
+uniform float bgl_RenderedTextureWidth;
+uniform float bgl_RenderedTextureHeight;
+
+#define PI    3.14159265
+
+float width = bgl_RenderedTextureWidth; //texture width
+float height = bgl_RenderedTextureHeight; //texture height
+
+//float near = 10; //Z-near
+//float far = 100; //Z-far
+
+float near = 0.5; //Z-near
+float far = 75.0; //Z-far
+
+int samples = 6; //samples on the first ring (5-10)
+int rings = 3; //ring count (2-6)
+
+//vec2 texCoord = gl_TexCoord[0].st;
+vec2 texCoord = v_tex;
+vec2 texcoord = v_tex;
+
+
+vec2 rand(in vec2 coord) //generating random noise
+{
+	float noiseX = (fract(sin(dot(coord ,vec2(12.9898,78.233))) * 43758.5453));
+	float noiseY = (fract(sin(dot(coord ,vec2(12.9898,78.233)*2.0)) * 43758.5453));
+	return vec2(noiseX,noiseY);
+}
+
+float readDepth(in vec2 coord) 
+{
+	return (2.0 * near) / (far + near - texture2D(bgl_DepthTexture, coord ).x * (far-near)); 	
+}
+
+float compareDepths( in float depth1, in float depth2 )
+{
+	float aoCap = 1.2;
+	float aoMultiplier = 250.0;
+	float depthTolerance = 0.0000;
+	float aorange = 2.5;// units in space the AO effect extends to (this gets divided by the camera far range
+	float diff = sqrt(clamp(1.0-(depth1-depth2) / (aorange/(far-near)),0.0,1.0));
+	float ao = min(aoCap,max(0.0,depth1-depth2-depthTolerance) * aoMultiplier) * diff;
+	return ao;
+}
+
+void main(void)
+{	
+	/*if (texture2D(bgl_DepthTexture, texcoord).x <= 0.5) 
+	{	
+	    gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+	    return;
+	}*/
+
+	float depth = readDepth(texCoord);
+	float d;
+	
+	float aspect = width/height;
+	vec2 noise = rand(texCoord)*0.003;
+	
+	float w = (0.001/depth+noise.x);
+	float h = (0.001/depth+noise.y);
+	
+	float pw;
+	float ph;
+
+	float ao;	
+	float s;
+	
+	for (int i = 0 ; i < rings; ++i)
+	{
+		for (int j = 0 ; j < samples; ++j)
+		{
+			float step = PI*2.0 / float(samples);
+			pw = (cos(float(j)*step)*float(i));
+			ph = (sin(float(j)*step)*float(i))*aspect;
+			d = readDepth( vec2(texCoord.s+pw*w,texCoord.t+ph*h));
+			ao += compareDepths(depth,d);	
+			s += 1.0;
+		}
+	}
+	
+	ao /= s;
+	ao = 1.0-ao;	
+    
+	vec3 color = texture2D(bgl_RenderedTexture,texCoord).rgb;
+	//vec3 luminance = texture2D(bgl_LuminanceTexture,texCoord).rgb;
+	vec3 luminance = vec3(dot(color, vec3(0.299, 0.587, 0.114)));
+	vec3 white = vec3(1.0,1.0,1.0);
+	vec3 black = vec3(0.0,0.0,0.0);
+	//vec3 treshold = vec3(0.2,0.2,0.2);
+
+	vec3 treshold = vec3(0.8);
+	
+	luminance = clamp(max(black,luminance-treshold)+max(black,luminance-treshold)+max(black,luminance-treshold),0.0,1.0);
+	
+	gl_FragColor = vec4(color*mix(vec3(ao,ao,ao),white,luminance),1.0);
+	//gl_FragColor = vec4(mix(vec3(ao,ao,ao),white,luminance),1.0);// vec4(color*vec3(ao,ao,ao),1.0);
+	//gl_FragColor = vec4(mix(vec3(ao,ao,ao),white,luminance),1.0);
+	//gl_FragColor = vec4(ao * color, 1.0);
+
+	//if (texcoord.x > 0.75) gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+}
+
+#if (0)
+
+vec2 rand(in vec2 coord) //generating random noise
+{
+	float noiseX = (fract(sin(dot(coord ,vec2(12.9898,78.233))) * 43758.5453));
+	float noiseY = (fract(sin(dot(coord ,vec2(12.9898,78.233)*2.0)) * 43758.5453));
+	return vec2(noiseX,noiseY);
+}
+
+float readDepth(in vec2 coord) 
+{
+	return (2.0 * near) / (far + near - texture2D(bgl_DepthTexture, coord ).x * (far-near)); 	
+}
+
+float compareDepths( in float depth1, in float depth2 )
+{
+	float aoCap = 1.0;
+	float aoMultiplier = 100.0;
+	float depthTolerance = 0.0000;
+	float aorange = 6.0;// units in space the AO effect extends to (this gets divided by the camera far range
+	float diff = sqrt(clamp(1.0-(depth1-depth2) / (aorange/(far-near)),0.0,1.0));
+	float ao = min(aoCap,max(0.0,depth1-depth2-depthTolerance) * aoMultiplier) * diff;
+	return ao;
+}
+
+void main(void)
+{	
+	float depth = readDepth(texCoord);
+	float d;
+	
+	float aspect = width/height;
+	vec2 noise = rand(texCoord)*0.003;
+	
+	float w = (0.001/depth+noise.x);
+	float h = (0.001/depth+noise.y);
+	
+	float pw;
+	float ph;
+
+	float ao;	
+	float s;
+	
+	for (int i = 0 ; i < rings; ++i)
+	{
+		for (int j = 0 ; j < samples; ++j)
+		{
+			float step = PI*2.0 / float(samples);
+			pw = (cos(float(j)*step)*float(i));
+			ph = (sin(float(j)*step)*float(i))*aspect;
+			d = readDepth( vec2(texCoord.s+pw*w,texCoord.t+ph*h));
+			ao += compareDepths(depth,d);	
+			s += 1.0;
+		}
+	}
+	
+	ao /= s;
+	ao = 1.0-ao;	
+    
+	vec3 color = texture2D(bgl_RenderedTexture,texCoord).rgb;
+	vec3 luminance = texture2D(bgl_LuminanceTexture,texCoord).rgb;
+	vec3 white = vec3(1.0,1.0,1.0);
+	vec3 black = vec3(0.0,0.0,0.0);
+	vec3 treshold = vec3(0.2,0.2,0.2);
+	
+	luminance = clamp(max(black,luminance-treshold)+max(black,luminance-treshold)+max(black,luminance-treshold),0.0,1.0);
+	
+	gl_FragColor = vec4(color*mix(vec3(ao,ao,ao),white,luminance), 1.0); //vec4(color*mix(vec3(ao,ao,ao),white,luminance),1.0);
+
+	//gl_FragColor = vec4(color*mix(vec3(ao,ao,ao),white,luminance),1.0);
+	//gl_FragColor = ao * texture2D(bgl_RenderedTexture, texCoord );
+	//gl_FragColor = ao;
+
+	//gl_FragColor = texture2D(bgl_RenderedTexture, texCoord);
+
+	if (texcoord.x > 0.5) gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+}
+
+#endif
+
+/*#define camx 100
+#define camy 200
+
+
+int j;
+int i;
+
+
+
+float readDepth( in vec2 coord ) {
+ return (2.0 * camx) / (camy + camx - texture2D(bgl_DepthTexture, coord ).x * (camy - camx)); 	
+}
+
+float compareDepths( in float depth1, in float depth2 ) {
+	float aoCap = 1.0;
+	float aoMultiplier=100.0;
+	float depthTolerance=0.0000;
+	float aorange = 20.0;// units in space the AO effect extends to (this gets divided by the camera far range
+	float diff = sqrt( clamp(1.0-(depth1-depth2) / (aorange/(camy-camx)),0.0,1.0) );
+	float ao = min(aoCap,max(0.0,depth1-depth2-depthTolerance) * aoMultiplier) * diff;
+	return ao;
+}
+
+void main(void)
+{	
+	//gl_FragColor = texture2D(bgl_RenderedTexture, texCoord);
+
+	float depth = readDepth( texCoord );
+	float d;
+	
+	float pw = 1.0 / float(width);
+	float ph = 1.0 / float(height);
+
+	float aoCap = 2.0;
+
+	float ao = 5.0;
+	
+	float aoMultiplier=1.0;
+
+	float depthTolerance = 0.0000;
+	
+	float aoscale=0.7;
+	
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+	
+	pw*=2.0;
+	ph*=2.0;
+	aoMultiplier/=2.0;
+	aoscale*=1.2;
+	
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	pw*=2.0;
+	ph*=2.0;
+	aoMultiplier/=2.0;
+	aoscale*=1.4;
+	
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+	
+	pw*=2.0;
+	ph*=2.0;
+	aoMultiplier/=2.0;
+	aoscale*=1.6;
+	
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+	
+	pw*=2.0;
+	ph*=2.0;
+	aoMultiplier/=2.0;
+	aoscale*=1.8;
+	
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t+ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s+pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+
+	d=readDepth( vec2(texCoord.s-pw,texCoord.t-ph));
+	ao+=compareDepths(depth,d)/aoscale;
+	
+	ao/=15.0;
+	
+    vec4 finalao = vec4(1.0-ao,1.0-ao,1.0-ao,1.0); 
+	finalao = clamp(finalao,0.0,0.7)+0.3;	
+    
+	gl_FragColor = finalao * texture2D(bgl_RenderedTexture, texCoord );
+	gl_FragColor.a = 1.0;  
+
+
+	gl_FragColor = texture2D(bgl_RenderedTexture, texCoord);
+}
+*/
\ No newline at end of file
Index: binaries/data/config/default.cfg
===================================================================
--- binaries/data/config/default.cfg	(revision 11919)
+++ binaries/data/config/default.cfg	(working copy)
@@ -58,7 +58,7 @@
 renderpath = default
 
 ; Prefer GLSL shaders over ARB shaders (not recommended)
-preferglsl = false
+preferglsl = true
 
 ; Replace alpha-blending with alpha-testing, for performance experiments
 forcealphatest = false
